<?php
//xbp_form - V 0.1.2 - 19/05/09

# ***** BEGIN LICENSE BLOCK *****
# This file is part of XBPlog. - htttp://www.xbplog.com 
# Copyright (c) 2006 LinkMan. All rights reserved.
#
# XBPlog is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#  
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****
class xbp_form implements ArrayAccess
{
	protected $_elements = array();
		
	public function add($name, $type, $value = null)
	{
		switch($type)
		{
			case 'textarea' :
			$this->addElement($name, array('type'=>'textarea','options'=>array('Cols'=>60,'Rows'=>5,'Wrap'=>'virtual')), $value);
			break;
			
			case 'checkbox' :
			$this->addElement($name, array('type'=>'checkbox','options'=>array('Checked'=>'')), $value);
			break;
			
			case 'select' :
			if (!is_array($value)) $value = array($value);
			$this->addElement($name, array('type'=>$type,'options'=>array('Opt'=>$value,'Size'=>'','J_S'=>'')), $value[0], $label);
			break;
			
			case 'radio' :
			$this->addElement($name, array('type'=>'radio','options'=>array('Opt'=>array($value))), $value);
			break;
			
			default:
			$this->addElement($name, array('type'=>'text','options'=>array('Size'=>'','Maxlength'=>'')), $value);
		}
	}
	
	/////////////////////////////////////////////////////
	//$type_options = 'text'; OR $type_options = array();
	// text : array('type'=>'text','options'=>array('Size'=>'','Maxlength'=>''))
	// textarea : array('type'=>'textarea')
	// checkbox : array('type'=>'checkbox','options'=>array('Checked'=>'on'))
	public function addElement($name, $type_options = array('type'=>'text','options'=>array('Size'=>'','Maxlength'=>'')), $value = '')
	{
		if (is_array($type_options)) {
			$lelement['TypeHTML'] = $type_options['type'];
			$lelement['Options'] = $type_options['options'];
		}
		else{
			$lelement['TypeHTML'] = $type_options;
			$lelement['Options'] = array();			
		}
		$lelement['Name'] = $name;
		$lelement['Value'] = $value;
		//$lelement['Other'] = '';
		$lelement['ID'] = count($this->_elements);

		$this->_elements[$lelement['ID']] = $lelement;		
	}
	

	
	
	public function getID($var){
		foreach ($this->_elements as $elmnt)
			if ($elmnt['Name'] == $var) return $elmnt['ID'];
		
		return -1;
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//ArrayAccess
	// Doit retourne TRUE / FALSE si loffset existe
	public function offsetExists($offset) {
		return isset($this->_elements[$offset]);
	}

	// Retourne la valeur pour $offset
	public function offsetGet($offset) {
		if(is_numeric($offset))return $this->getField($offset);
		else {
		 $lID = $this->getID($offset);
		 if($lID >= 0)return $this->getField($lID);
		 else return false;
		}
	}

	// Trois possibilits :
	// $f[] = array('a','text'); : Cre le champ a 
	// $f['a'] = '20'; : Donne la valeur 20 au champ 
	// $f['a'] = array('Size'=>50); : Met la valeur 50  la taille
	public function offsetSet($offset, $value) {
		$offset = $this->getID($offset);
		if ($offset > -1) 
			return (is_array($value)) ? 
				$this->setE($offset, $value) : 
				$this->_elements[$offset]['Value'] = $value;
		else
			return $this->add($value[0],$value[1],$value[2]);		
	}
	private function setE($offset, $array_value)
	{
		if (!is_numeric($offset)) $offset = $this->getID($offset);
		if ($offset == -1) return false;
		$offset = &$this->_elements[$offset];
		
		foreach($array_value as $key => $var)
		{
			if (isset($offset[$key])) $offset[$key] = $var;
			else $offset['Options'][$key] = $var;
		}
		
		return true;
	}

	// Supprime la valeur  l$offset
	public function offsetUnset($offset) {
		unset($this->_elements[$offset]);
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	private function moveTo($offset,$position, $direction)
	{
		if ($offset != $position)
		{
			$tmp = $this->_elements[$offset]; 
			$this->_elements[$offset] = $this->_elements[$offset+$direction];
			$this->_elements[$offset+$direction] = $tmp;
			$this->moveTo($offset+$direction,$position,$direction);
		}
		else
		{
			foreach ($this->_elements as $key => $var)
				$this->_elements[$key]['ID'] = $key;
			return true;
		}
	}	
	public function position($offset, $position)
	{
		$nbr = count($this->_elements);
		if ($position >= $nbr) return false;
		if (!is_numeric($offset)) $offset = $this->getID($offset);
		if ($offset == $position) return true;
		
		($position < $offset) ? $this->moveTo($offset, $position, -1) : $this->moveTo($offset, $position, 1);
		
		return true;
	}
	

	/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//GET	
	public function getField($offset){
		switch($this->_elements[$offset]['TypeHTML']){
			case 'text' : return $this->getInputText($this->_elements[$offset]['ID']);
			case 'password' : return $this->getInputText($this->_elements[$offset]['ID'],'password');
			case 'hidden' : return $this->getInputText($this->_elements[$offset]['ID'],'hidden');
			
			case 'textarea' : return $this->getTextarea($this->_elements[$offset]['ID']);
			
			case 'select' : return $this->getSelect($this->_elements[$offset]['ID']);
			
			case 'checkbox' : return $this->getCheckbox($this->_elements[$offset]['ID']);
			
			case 'radio' : return $this->getRadio($this->_elements[$offset]['ID']);
		}
		
		return null;
	}
	
	public function getInputText($ID,$type = 'text'){
		 $lfield = '<input type="'.$type.'" name="'.$this->_elements[$ID]['Name'].'"';
		 $lfield .= ' size="'.$this->_elements[$ID]['Options']['Size'].'"';
		 $lfield .= ' maxlength="'.$this->_elements[$ID]['Options']['Maxlength'].'"';
		 $lfield .= ' value="'.$this->_elements[$ID]['Value'].'"';
		 $lfield .= ' />';
		 
		 return $lfield;
	}
	public function getTextarea($ID){
		$lfield = '<textarea cols="'.$this->_elements[$ID]['Options']['Cols'].'" rows="'.$this->_elements[$ID]['Options']['Rows'].'" ';
		$lfield .= 'name="'.$this->_elements[$ID]['Name'].'">';
		$lfield .= $this->_elements[$ID]['Value'].'</textarea>';
		
		return $lfield;
	}	
	public function getSelect($ID){
		return $this->buildSelect($this->_elements[$ID]['Name'],$this->_elements[$ID]['Options']['Opt'],
									$this->_elements[$ID]['Value'], 
									$this->_elements[$ID]['Options']['J_S']);
	}
	public static function buildSelect($name,$opts,$value_selected='',$j_s = '')
	{
		if ($j_s != '') $j_s = ' onchange="'.$j_s.'"';

		$sel = '<select name="'.$name.'"'.$j_s.'>';
		foreach($opts as $key => $var)
		{
			$selected = ($var == $value_selected) ? ' selected="selected"' : '';
			if (is_numeric($key)) 
			{ 
				$key = $var; $var = ''; 
			}
			else $var = ' value="'.$var.'"';
			
			$sel .= '<option'.$var.$selected.'>'.$key.'</option>';
		}
		$sel .= '</select>';
		
		return $sel;
	}
	public function getCheckbox($ID){
		$checked = ($this->_elements[$ID]['Options']['Checked'] == 'on') ? 'checked="checked"' : null;
		return '<input type="checkbox" name="'.$this->_elements[$ID]['Name'].'" value="'.$this->_elements[$ID]['Value'].'" '.$checked.'/>';
	}	
	public function getRadio($ID){
		$radio = '';
		foreach($this->_elements[$ID]['Options']['Opt'] as $opt){
			//is_array
			$radio .= '<input type="radio" name="'.$this->_elements[$ID]['Name'].'" value="'.$opt.'" /> '.$opt.' ';
		}			
		return $radio;
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public function getBSubmit($value='Envoyer'){
		return '<input type="submit" value="'.$value.'" />';
	}
	
	
	public function generateTableHTML($show = 1){
		$tab_arg = func_get_args(); array_shift($tab_arg);
		
		$table = '<form action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n".'<table border="0">'."\n";
		
		foreach($this->_elements as $key => $elmnt)
		{
			if (($show == 1 && !in_array($elmnt['Name'], $tab_arg)) || ($show == 2 && in_array($elmnt['Name'], $tab_arg))) {
				$table .= '<tr><td>'.$elmnt['Name'].' : </td><td>'.$this->getField($key).'</td></tr>'."\n";
			}
		}
		return $table.'<tr><td colspan="2">'.$this->getBSubmit().'</td></tr></table></form>';
	}
	

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//$var = $_POST ou $_GET
	//$er = 1 Laisse rien pass sauf ... // $er = 2 Laisse tout passer sauf ...	
	function checkForm($var, $er = 1){
	 if (empty($var)) return false;
	 
	 $tab_arg = func_get_args();
	 array_shift($tab_arg); array_shift($tab_arg);
	 
	 foreach($var as $key => $value){
		$lID = $this->getID($key);
		if($lID >= 0){
			if (empty($value) && (
								  ($er == 1 && !in_array($key, $tab_arg) && $this->_elements[$lID]['TypeHTML'] != 'checkbox' ) || 
								  ($er == 2 && in_array($key, $tab_arg))
								 )
				) $tab_er[] = $key;
		}
	 }
	 
	 if (isset($tab_er)) return $tab_er;
	 else return true;
	}	
}
?>